routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('index');
});

Auth::routes(['verify' => true]);

Route::get('/home', 'HomeController@index')->name('home');

Route::post('admin/login', 'Admin\AdminController@login');
Route::group(['middleware' => ['auth:admin,admin_tutor']], function(){
    Route::post('admin/logout', 'Admin\AdminController@logout');
    Route::get('materi/get/{type}/{name}/{ext}', 'Admin\MateriController@get');
    Route::get('admin/materi/generate-thumbnail', 'Admin\MateriController@generateThumbs');
    Route::resource('admin/materi', 'Admin\MateriController');
    Route::resource('admin/kategori', 'Admin\KategoriController');
    Route::resource('admin/sekolah', 'Admin\SekolahController');
    Route::resource('admin/guru', 'Admin\GuruController');
    Route::resource('admin/soal', 'Admin\SoalController');
    Route::get('admin/user/resetpass/{id}', 'Admin\UserController@resetpass')->name('user-resetpass');
    Route::post('admin/user/add/single', 'Admin\UserController@single')->name('user-single');
    Route::post('admin/user/add/bulk', 'Admin\UserController@bulk')->name('user-bulk');
    Route::get('admin/user/add/bulk', function (){
        return response()->download(storage_path('app/public/template.xls'));
    })->name('user-bulk-template');
    Route::resource('admin/user', 'Admin\UserController');
    Route::resource('admin/tutor', 'Admin\TutorController');
    Route::resource('admin/payment', 'Admin\PaymentController');
    Route::post('admin/subscription/add/bulk', 'Admin\SubscriptionController@bulk')->name('subscription-bulk');
    Route::resource('admin/subscription', 'Admin\SubscriptionController');
    Route::resource('admin/news', 'Admin\NewsController');
    Route::resource('admin/settings', 'Admin\ServerSettingsController');
    Route::resource('admin/lembaga', 'Admin\LembagaController');
    Route::post('admin/nilai/delcid', 'Admin\ScoreController@deleteScoreCID')->name('delete-score-cid');
    Route::post('admin/nilai/massscoredelete', 'Admin\ScoreController@massScoreDelete')->name('mass-score-delete');
    Route::get('admin/nilai/hapuslaporan', 'Admin\ScoreController@massScoreDeleteView');
    Route::resource('admin/nilai', 'Admin\ScoreController');
    Route::resource('admin', 'Admin\AdminController');
});

app/Subscription.php
<?php

namespace App;

use Carbon\Carbon;
use Illuminate\Database\Eloquent\Model;

class Subscription extends Model
{
    //

    protected $table = 'subscriptions';
    protected $fillable = [
        'uid', 'start_date', 'end_date', 'type_subs'
    ];

    public function user()
    {
        return $this->belongsTo('App\User', 'uid', 'id');
    }

    public function setEndDateAttribute($value)
    {
        $this->attributes['end_date'] = !empty($value) ? Carbon::createFromFormat(config('app.date_format'), $value)->format('Y-m-d') : null;
    }

    public function getEndDateAttribute($value)
    {
        return is_null($value) ? null : Carbon::parse($value)->format(config('app.date_format'));
    }

    public function setStartDateAttribute($value)
    {
        $this->attributes['start_date'] = !empty($value) ? Carbon::createFromFormat(config('app.date_format'), $value)->format('Y-m-d') : null;
    }

    public function getStartDateAttribute($value)
    {
        return is_null($value) ? null : Carbon::parse($value)->format(config('app.date_format'));
    }

    public function payment(){
        return $this->hasMany('App\Payment', 'user_id', 'uid');
    }
}

app/Http/Controllers/API/SubscriptionController.php
<?php

namespace App\Http\Controllers\API;

use App\Payment;
use App\Subscription;
use App\User;
use Auth;
use Carbon\Carbon;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;

class SubscriptionController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\JsonResponse|\Illuminate\Http\Response
     */
    public function index()
    {
        //
        $payment_status = 0;
        $subscribe = Subscription::where('uid', Auth::id())->with('payment')->latest()->first();
        if (!isset($subscribe)) {
            $payment = Payment::where('user_id', Auth::id())->get();
            if (isset($payment)){
                if ($payment->contains('active', 1)){
                    $payment_status = 1;
                }
                elseif ($payment->contains('active', 2)){
                    $payment_status = 2;
                }
                return response()->json([
                    'status' => 0,
                    'payment' => $payment_status,
                ]);
            }
        }
        else {
            if (isset($subscribe->end_date)){
                $daysleft = Carbon::parse(Carbon::now())->diffInDays(Carbon::createFromFormat(config('app.date_format'), Auth::user()->subscription->end_date), false);
                if ($daysleft >= 0){
                    $subscribe = array_merge($subscribe->toArray(), ['daysleft' => $daysleft]);
                    return response()->json([
                        'status' => 1,
                        'subscription' => $subscribe,
                        'payment' => 3
                    ]);
                }
                else {
                    $payment = Payment::where('user_id', Auth::id())->where('active', 2)->first();
                    if (isset($payment)){
                        $payment->active = 3;
                        $payment->save();
                    }
                    return response()->json([
                        'status' => 0,
                        'payment' => $payment_status,
                    ]);
                }
            }
            else {
                return response()->json([
                    'status' => 0,
                    'payment' => $payment_status
                ]);
            }
        }
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param \Illuminate\Http\Request $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //

    }

    /**
     * Display the specified resource.
     *
     * @param int $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param \Illuminate\Http\Request $request
     * @param int $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param int $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}

app/Http/Controllers/Admin/SubscriptionController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Jobs\ImportJob;
use App\Jobs\ImportSubscription;
use App\Subscription;
use App\User;
use Carbon\Carbon;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Validation\ValidationException;

class SubscriptionController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        //
        return response(view('admin.subscription.index')->with([
            'users' => User::with('subscription')->get()
        ]));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
        return response(view('admin.subscription.create'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param \Illuminate\Http\Request $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     *
     * @param int $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param int $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param \Illuminate\Http\Request $request
     * @param int $id
     * @return \Illuminate\Http\RedirectResponse|\Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
        if ($request->has('end_date')) {
            $end_date = Carbon::createFromFormat(config('app.date_format'), $request->end_date);
            if ($request->has('start_date')) {
                if (!empty($request->start_date)){
                    $start_date = Carbon::createFromFormat(config('app.date_format'), $request->start_date);
                    if (strtotime($start_date) > strtotime($end_date)){
                        return redirect()->back()->with([
                            'error' => 'Gagal merubah subscription: <b>tanggal akhir langganan tidak boleh lebih kecil dari tangal awal langganan</b>',
                            'users' => User::with('subscription')->get()
                        ]);
                    }
                }
                if (strtotime(Carbon::now()) > strtotime($end_date)){
                    return redirect()->back()->with([
                        'error' => 'Gagal merubah subscription: <b>tanggal akhir langganan tidak boleh lebih kecil dari tangal sekarang</b>',
                        'users' => User::with('subscription')->get()
                    ]);
                }
            }
            $subscribe = Subscription::updateOrCreate(
                ['uid' => $id],
                [
                    'start_date' => Carbon::now()->format(config('app.date_format')),
                    'end_date' => $request->end_date,
                    'type_subs' => $request->type_subs
                ]
            );
            if ($subscribe->wasRecentlyCreated) {
                return redirect()->back()->with([
                        'success' => 'Berhasil menambah subscription: <b> ' . $subscribe->user->name . '</b>',
                        'users' => User::with('subscription')->get()
                    ]
                );
            }
            if ($subscribe->wasChanged()) {
                return redirect()->back()->with([
                    'success' => 'Berhasil mengubah subscription: <b> ' . $subscribe->user->name . '</b>',
                    'users' => User::with('subscription')->get()
                ]);
            }
        }
        return redirect()->back();
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param int $id
     * @return \Illuminate\Http\RedirectResponse|\Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
        $subscribe = Subscription::where('uid', $id)->with('user')->first();
        $subscribe->start_date = null;
        $subscribe->end_date = null;
        $subscribe->type_subs = null;
        $saved = $subscribe->save();
        if ($saved) return redirect()->back()->with([
            'success' => 'Berhasil menghapus langganan: <b>' . $subscribe->user->name . '</b>',
            'users' => User::with('subscription')->get()
        ]);
        elseif (!$saved) return redirect()->back()->with([
            'error' => 'Gagal menghapus langganan: <b>' . $subscribe->user->name . '</b>',
            'users' => User::with('subscription')->get()
        ]);
    }

    public function bulk(Request $request)
    {
        //
        try {
            $this->validate($request, [
                'file' => 'required'
            ]);
        } catch (ValidationException $e) {
        }

        if ($request->hasFile('file')) {
            $file = $request->file('file');
            $filename = time() . '.' . $file->getClientOriginalExtension();

            $file->storeAs(
                'import', $filename
            );
            $this->replaceDelimiters(public_path('storage/import/' . $filename));
            ImportSubscription::dispatch($filename, $request->start_date, $request->end_date, $request->type_subs);

            return redirect()->back()->with('success', 'Upload success');
        }
        return redirect()->back()->with('error', 'Failed to upload file');
    }

    private function replaceDelimiters($file)
    {
        // Delimiters to be replaced: pipe, comma, semicolon, caret, tabs
        $delimiters = array('|', ';', '^', "\t");
        $delimiter = ',';

        $str = file_get_contents($file);
        $str = str_replace($delimiters, $delimiter, $str);
        file_put_contents($file, $str);
    }
}

resources/views/admin/subscription/create.blade.php
@extends('adminlte::page')

@section('title', 'Tambah Subscription')

@section('content_header')
    <h1>Tambah Subscription</h1>
    @if (($message = Session::get('success')) || ($message = Session::get('error')))
        <div class="alert alert-{{ Session::get('success') ? 'success' : 'danger'}} alert-dismissible">
            <button type="button" class="close" data-dismiss="alert" aria-hidden="true">&times;</button>
            {!! $message !!}
        </div>
    @endif
@endsection

@section('content')
    <div class="row">
        <div class="col-md-12">
            <div class="box">
                <div class="box-body">
                    <div class="row">
                        <div class="col-md-3 col-sm-6 col-xs-12">
                            <div class="info-box">
                                <button type="button" class="btn btn-block btn-primary btn-lg" data-toggle="modal"
                                        data-target="#modal-bulk">Bulk
                                </button>
                                <div class="modal fade" id="modal-bulk" style="display: none;">
                                    <div class="modal-dialog">
                                        <div class="modal-content">
                                            <form action="{{ route('subscription-bulk') }}" method="POST"
                                                  enctype="multipart/form-data">
                                                <div class="modal-header">
                                                    <button type="button" class="close" data-dismiss="modal"
                                                            aria-label="Close">
                                                        <span aria-hidden="true">×</span></button>
                                                    <h4 class="modal-title">Add Bulk Subscription</h4>
                                                </div>
                                                <div class="modal-body">
                                                    @csrf
                                                    <div class="form-group">
                                                        <label for="">Import Data</label>
                                                        <input type="file" accept=".csv" name="file"
                                                               class="{{ $errors->has('file') ? 'is-invalid':'' }}"
                                                               required>
                                                        <p class="text-danger">{{ $errors->first('file') }}</p>
                                                    </div>
                                                    <div class="form-group">
                                                        <label for="start_date">Awal Berlangganan</label>
                                                        <div class="input-group date">
                                                            <div class="input-group-addon">
                                                                <i class="fa fa-calendar"></i>
                                                            </div>
                                                            <input type="text" class="form-control pull-right"
                                                                   id="start_date" name="start_date"
                                                                   placeholder="-" autocomplete="off" required>
                                                        </div>
                                                    </div>
                                                    <div class="form-group">
                                                        <label for="end_date">Akhir Berlangganan</label>
                                                        <div class="input-group date">
                                                            <div class="input-group-addon">
                                                                <i class="fa fa-calendar"></i>
                                                            </div>
                                                            <input type="text" class="form-control pull-right"
                                                                   id="end_date" name="end_date"
                                                                   placeholder="-" autocomplete="off" required>
                                                        </div>
                                                    </div>
                                                    <div class="form-group">
                                                        <label for="type_subs">Paket Langganan</label><select name="type_subs" id="type_subs" class="form-control lembaga" style="width: 100%" required>
                                                            <option value="1">Trial</option>
                                                            <option value="2">Beginner</option>
                                                            <option value="3">Intermediate</option>
                                                            <option value="4">Advance</option>
                                                        </select>
                                                    </div>
                                                </div>
                                                <div class="modal-footer">
                                                    <button type="button" class="btn btn-default"
                                                            data-dismiss="modal">Batal
                                                    </button>
                                                    <button type="submit" class="btn btn-primary">Tambah Subscription</button>
                                                </div>
                                            </form>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection

@section('js')
    <script>
        $(function () {
            $("#type_subs").select2();
            $('#start_date').datepicker({
                autoclose: true,
                format: '{{ config('app.date_format_javascript') }}',
                locale: 'en'
            }).on("changeDate", function (e) {
                $('#start_date').attr('value', e.format());
            });
            $('#end_date').datepicker({
                autoclose: true,
                format: '{{ config('app.date_format_javascript') }}',
                locale: 'en'
            }).on("changeDate", function (e) {
                $('#end_date').attr('value', e.format());
            });
        });
    </script>
@endsection

resources/views/admin/subscription/edit.blade.php
@extends('adminlte::page')

@section('title', 'Subscription')

@section('content_header')

@endsection

@section('content')

@endsection

@section('js')

@endsection

resources/views/admin/subscription/index.blade.php
@extends('adminlte::page')

@section('title', 'Subscription')

@section('content_header')
  <h1>User Subscription</h1>
  @if (($message = Session::get('success')) || ($message = Session::get('error')))
    <div class="alert alert-{{ Session::get('success') ? 'success' : 'danger'}} alert-dismissible">
      <button type="button" class="close" data-dismiss="alert" aria-hidden="true">&times;</button>
      {!! $message !!}
    </div>
  @endif
@endsection

@section('content')
  @php($start = 0)
  <div class="row">
    <div class="col-md-12">
      <div class="box">
        <div class="box-body">
          <div class="row">
            <div class="col-md-12">
              <table id="user" class="table table-bordered table-striped table-responsive" style="width: 100%">
                <thead>
                  <tr>
                    <th style="width: 1%">No.</th>
                    <th>Nama</th>
                    <th>Email</th>
                    <th>No. HP</th>
                    <th>Lembaga</th>
                    <th>Awal Berlangganan</th>
                    <th>Akhir Berlangganan</th>
                    <th>Tipe Langganan</th>
                    <th style="width: 10%">Aksi</th>
                  </tr>
                </thead>
                <tbody>
                  @foreach($users as $user)
                    <tr>
                      <td>{{ ++$start }}.</td>
                      <td>{{ $user->name }}</td>
                      <td>{{ $user->email }}</td>
                      <td>{{ isset($user->no_hp) ? $user->no_hp : '-' }}</td>
                      <td>
                        @if(isset($user->lembaga))
                            {{ $user->rel_lembaga->nama }}
                        @endif
                      </td>
                      <td>{{ isset($user->subscription) && !is_null($user->subscription->start_date) ? $user->subscription->start_date : "-" }}</td>
                      <td>{{ isset($user->subscription) && !is_null($user->subscription->start_date) ? $user->subscription->end_date : "-" }}</td>
                      <td>
                        @if(isset($user->subscription->type_subs))
                          @switch($user->subscription->type_subs)
                            @case(1)
                            Trial
                            @break
                            @case(2)
                            Beginner
                            @break
                            @case(3)
                            Intermediate
                            @break
                            @case(4)
                            Advance
                            @break
                          @endswitch
                        @else
                          Belum ditentukan
                        @endif
                      </td>
                      <td align="center">
                        <button type="button" class="btn btn-primary btn-sm" data-toggle="modal"
                        data-target="#aksi-{{ $user->id }}">AKSI
                      </button>
                    </td>
                  </tr>
                @endforeach
              </tbody>
            </table>
          </div>
        </div>
      </div>
    </div>
  </div>
</div>
@foreach($users as $user)
  <div class="modal fade" id="aksi-{{ $user->id }}" style="display: none;">
    <div class="modal-dialog">
      <div class="modal-content">
        <form action="{{ route('subscription.update', $user->id) }}" method="POST">
          @method('PATCH')
          <div class="modal-header">
            <button type="button" class="close" data-dismiss="modal"
            aria-label="Close">
            <span aria-hidden="true">×</span></button>
            <h4 class="modal-title">Subscription: {{ $user->name }}</h4>
          </div>
          <div class="modal-body">
            @csrf
            <div class="form-group">
              <label for="type_subs">Type Langganan</label>
              <select id="type_subs" name="type_subs" class="form-control" required>
                <option value="1" {{ isset($user->subscription->type_subs) && $user->subscription->type_subs == 1 ? "selected" : "" }}>Trial - 15 Materi</option>
                <option value="2" {{ isset($user->subscription->type_subs) && $user->subscription->type_subs == 2 ? "selected" : "" }}>Beginner - 45 Materi</option>
                <option value="3" {{ isset($user->subscription->type_subs) && $user->subscription->type_subs == 3 ? "selected" : "" }}>Intermediate - 63 Materi</option>
                <option value="4" {{ isset($user->subscription->type_subs) && $user->subscription->type_subs == 4 ? "selected" : "" }}>Advance - Semua Materi</option>
              </select>
            </div>
            <div class="form-group">
              <label for="datestart">Awal Berlangganan</label>
              <div class="input-group date">
                <div class="input-group-addon">
                  <i class="fa fa-calendar"></i>
                </div>
                <input type="text" class="form-control pull-right"
                id="datestart" name="start_date" readonly
                value="{{ isset($user->subscription) ? $user->subscription->start_date : "" }}"
                placeholder="-">
              </div>
            </div>
            <div class="form-group">
              <label for="dateend-{{ $user->id }}">Akhir Berlangganan</label>
              <div class="input-group date">
                <div class="input-group-addon">
                  <i class="fa fa-calendar"></i>
                </div>
                <input type="text" class="form-control pull-right"
                id="dateend-{{ $user->id }}" name="end_date"
                value="{{ isset($user->subscription) ? $user->subscription->end_date : "" }}"
                placeholder="-" autocomplete="off" required>
              </div>
            </div>
          </div>
          <div class="modal-footer">
            @if(isset($user->subscription))
              <button type="submit" class="btn btn-danger pull-left" form="del-subs-{{ $user->id }}">
                Nonaktif Berlangganan
              </button>
            @endif
            <button type="button" class="btn btn-default"
            data-dismiss="modal">Batal
          </button>
          <button type="submit" class="btn btn-primary">Simpan</button>
        </div>
      </form>
      <form action="{{ route('subscription.destroy', $user->id) }}" method="post"
        id="del-subs-{{ $user->id }}">
        @csrf
        @method('DELETE')
      </form>
    </div>
  </div>
</div>
@endforeach
@endsection

@section('js')
  <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/pdfmake/0.1.36/pdfmake.min.js"></script>
  <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/pdfmake/0.1.36/vfs_fonts.js"></script>
  <script type="text/javascript"
          src="https://cdn.datatables.net/v/bs/jszip-2.5.0/dt-1.10.18/b-1.5.6/b-html5-1.5.6/b-print-1.5.6/datatables.min.js"></script>
  <script>
  $(document).ready(function () {
    var table = $("#user").DataTable({
      buttons: [
        {
          extend: 'copy',
          exportOptions: {
            columns: 'th:not(:last-child)'
          }
        },
        {
          extend: 'excel',
          exportOptions: {
            columns: 'th:not(:last-child)'
          }
        },
        {
          extend: 'pdf',
          exportOptions: {
            columns: 'th:not(:last-child)'
          }
        }
      ]
    });
    table.buttons().container()
    .appendTo($('.col-sm-6:eq(0)', table.table().container()));
    @foreach($users as $user)
    $('#dateend-{{ $user->id }}').datepicker({
      autoclose: true,
      format: '{{ config('app.date_format_javascript') }}',
      locale: 'en',
      startDate: new Date()
    }).on("changeDate", function (e) {
      $('#dateend-{{ $user->id }}').attr('value', e.format());
    });
    @endforeach
  });
  </script>
@endsection

resources/views/admin/subscription/show.blade.php
@extends('adminlte::page')

@section('title', 'Subscription')

@section('content_header')

@endsection

@section('content')

@endsection

@section('js')

@endsection